#
# spec file for package ghc-deepseq-generics
#
# Copyright (c) 2015 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

%global pkg_name deepseq-generics

%bcond_with tests

# no useful debuginfo for Haskell packages without C sources
%global debug_package %{nil}

Name:           ghc-deepseq-generics
Version:        0.1.1.2
Release:        4.4
Summary:        GHC.Generics-based Control.DeepSeq.rnf implementation
Group:          Development/Languages/Other 
License:        BSD-3-Clause
Url:            http://hackage.haskell.org/package/%{pkg_name}
Source0:        http://hackage.haskell.org/packages/archive/%{pkg_name}/%{version}/%{pkg_name}-%{version}.tar.gz
# PATCH-FIX-UPSTREAM deepseq-generics.cabal.patch fix dependency constraints - mimi.vx@gmail.com
Patch0:         deepseq-generics.cabal.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros
# Begin cabal-rpm deps:
BuildRequires:  ghc-deepseq-devel
%if %{with tests}
BuildRequires:  ghc-HUnit-devel
BuildRequires:  ghc-test-framework-devel
BuildRequires:  ghc-test-framework-hunit-devel
%endif
# End cabal-rpm deps

%description
This package provides a "GHC.Generics"-based
'Control.DeepSeq.Generics.genericRnf' function which can be used for providing
a 'rnf' implementation. See the documentation for the 'genericRnf' function in
the "Control.DeepSeq.Generics" module to get started.

The original idea was pioneered in the 'generic-deepseq' package (see
<http://www.haskell.org/pipermail/haskell-cafe/2012-February/099551.html> for
more information).

This package differs from the 'generic-deepseq' package by working in
combination with the existing 'deepseq' package as opposed to defining a
conflicting drop-in replacement for 'deepseq''s 'Control.Deepseq' module.

Note: The ability to auto-derive via "GHC.Generics" has been merged into
'deepseq-1.4.0.0'. This package is now still useful for writing code that's
also compatible with older 'deepseq' versions not yet providing
"GHC.Generics"-support.


%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Other
Requires:       %{name} = %{version}-%{release}

%description devel
This package provides the Haskell %{pkg_name} library development
files.


%prep
%setup -q -n %{pkg_name}-%{version}
%patch0 -p1

%build
%ghc_lib_build


%install
%ghc_lib_install


%check
%if %{with tests}
%cabal test
%endif


%post devel
%ghc_pkg_recache


%postun devel
%ghc_pkg_recache


%files -f %{name}.files
%defattr(-,root,root,-)
%doc LICENSE


%files devel -f %{name}-devel.files
%defattr(-,root,root,-)


%changelog
* Tue May 12 2015 mimi.vx@gmail.com
- add deepseq-generics.cabal.patch -- change dep constraints
* Tue Feb  3 2015 mimi.vx@gmail.com
- initial commit of deepseq-generics ver - 0.1.1.2
